<!-- <svelte:options
  customElement={{
    tag: "wc-score",
    shadow: "none",
  }}
/> -->

<script>
  import { createEventDispatcher, onMount } from "svelte";
  // GLOBAL scope
  export let data = {};
  export let isEditing = false;
  export const isPrinting = false;
  export let src = "";
  //// CST -------------------------------------------->
  const DENOMINATOR_TXT = "Afficher le dénominateur : ";
  const CAPTION_TXT = "Afficher la légende des points : ";
  const ADD_QUESTION_TXT = "AJOUTER une question ? ";
  const ON_TXT = "Sur combien de points ?";
  const ON_WEIGHT = "Quel poid pour chaque point (commence à zéro)";
  const RANGE_WEIGHT_TXT = "Définir un texte pour les plages de résultat";
  //// <------------------------------------------- ////
  let _new_label = "";
  let _new_description = "";
  // WATCH
  // Event dispatcher on:scoreChange
  let dispatch = createEventDispatcher();

  $: _final.on && onOnChanged();

  // LOCAL copy
  let _data = data;
  // Label and Questions !!???
  let _label = _data["label"] || "";
  let _questions = _data["questions"] || [];
  // Final score and denominator display
  let _final = _data["final"] || {
    score: 0,
    on: 5,
    denominator: {
      isShow: true,
      score: 0,
    },
  };
  // Checkbox caption display text
  let _caption = _data["caption"] || {
    isShow: true,
    values: new Array(_final.on).fill(""),
  };

  let _resume = _data["resume"] || {
    isShow: false,
    values: new Array(_final.on).fill(""),
  };

  onMount(() => {
    console.log(src);
    if (src === "") return;

    return fetchData().then((data) => {
      _data = data;
      console.log(_data);
      // Label and Questions !!???
      _label = _data["label"] || "";
      _questions = _data["questions"] || [];
      // Final score and denominator display
      _final = _data["final"] || {
        on: 5,
        denominator: {
          isShow: true,
        },
        resume: {
          isShow: false,
        },
      };
      // Checkbox caption display text
      _caption = _data["caption"] || {
        isShow: false,
        values: new Array(_final.on).fill(""),
      };

      _resume = _data["resume"] || {
        isShow: false,
        values: new Array(_final.on - 1).fill(""),
      };

      // Calculate score ===>
      calculateFinalScore();
    });
  });

  const fetchData = async () => {
    const fetchHeaders = new Headers({
      Accept: "application/json",
    });

    const response = await fetch(src, {
      cache: "default",
      headers: fetchHeaders,
      method: "GET",
      mode: "cors",
    });

    return await response.json();
  };

  const checkChanged = (e) => {
    const [questionId, checkId] = e.currentTarget.getAttribute("id").split("#");
    // Change the checked radio button for the right question
    _questions[questionId].checked = +checkId;
    // Calculate score ===>
    calculateFinalScore();
    // Dispatch event to the Parent
    dispatch("scoreChange", _data);
  };

  const clearQuestionValues = () => {
    _new_label = "";
    _new_description = "";
  };

  const addQuestion = () => {
    let new_question = {
      id: 0,
      label: _new_label,
      description: _new_description,
      checked: 0,
    };

    if (!_data.questions) {
      _data["questions"] = new Array(new_question);
    } else {
      new_question = Object.assign(new_question, { id: _questions.length });
      _data.questions.push(new_question);
    }
    // Update Question List
    _questions = _data["questions"];
    // Update Data Score
    clearQuestionValues();
    calculateFinalScore();
  };

  const getWeightNumber = (i) => {
    return +i * _final.weight;
  };

  const getRangeTextValue = (i) => {
    // Range Text Value is :
    //
    return "Range Value";
  };

  const onOnChanged = () => {
    if (!_final.on) return;
    // We should now adjust ::
    // Caption Size Array ...
    let currentCaptionValuesLength = _caption.values.length;
    // Range Text Values ...Range Text Values
    let currentResumeValuesLength = _resume.values.length;

    // AND
    // Final Score
    console.log(
      `On :: ${_final.on} we adjust caption to ${currentCaptionValuesLength} and resume to ${currentResumeValuesLength}`,
    );

    calculateFinalScore();
  };

  const getResumeScoreTetx = (score) => {
    for (const { min, max, text } of _resume.values) {
      if (score <= max && score >= min) return text;
    }
  };

  const calculateFinalScore = () => {
    let score = 0;

    for (const { checked } of _questions) {
      score += checked;
    }

    _final.score = score;
    _final.denominator.score = _questions.length * (_final.on - 1);

    _resume.scoreText = getResumeScoreTetx(_final.score);
  };

  // Display final Score
  calculateFinalScore();
</script>

{#if isEditing}
  <label>Label : <input type="text" bind:value={_label} /></label>
  <label
    >{DENOMINATOR_TXT}<input
      type="checkbox"
      bind:checked={_final["denominator"].isShow}
    /></label
  >
  <!-- ON how many points ?? -->
  <slot>
    <label
      >{ON_TXT}
      <input type="number" min="1" bind:value={_final.on} />
    </label>
  </slot>
  <!-- WEIGHT if each point has weight -->
  <slot>
    <label
      >{ON_WEIGHT}
      <input type="number" min="1" bind:value={_final.weight} />
    </label>
  </slot>

  <slot>
    <label
      >{CAPTION_TXT}<input
        type="checkbox"
        bind:checked={_caption["isShow"]}
      /></label
    >
    {#if _caption.isShow}
      {#each _caption["values"] as value}
        <input type="text" bind:value />
      {/each}
    {/if}
  </slot>

  <slot>
    <label
      >{RANGE_WEIGHT_TXT}<input
        type="checkbox"
        bind:checked={_resume["isShow"]}
      /></label
    >
    {#if _resume.isShow}
      {#each _resume["values"] as { min, max, text }, i}
        <label>
          {min} &#60; {max}
          <input type="text" bind:value={text} />
        </label>
      {/each}
    {/if}
  </slot>
  <h3>ADD QUESTION :::</h3>
  <slot>
    <input type="text" bind:value={_new_label} />
    <input type="text" bind:value={_new_description} />
    <button
      on:click={addQuestion}
      disabled={_new_label === "" || _new_description === ""}
      >{ADD_QUESTION_TXT}</button
    >
  </slot>
  <h3>Questions :::</h3>
  {#each _questions as { label, description }, i}
    <li>{label} :: {description}</li>
    <input type="text" bind:value={label} />
    <input type="text" bind:value={description} />
  {/each}
{/if}

{#if !isEditing}
  <fieldset>
    <legend>{@html _label}</legend>

    {#each _questions as { label, description, checked }, i}
      <li>{label} :: {description}</li>
      {#each { length: _final.on } as _, idx}
        {#if _caption?.isShow}
          {_caption.values[idx]}
        {/if}
        <input
          type="radio"
          on:change={checkChanged}
          id={`${i.toString()}#${idx.toString()}`}
          checked={checked === idx}
        />
      {/each}
    {/each}

    <p>
      Score :: {_final.score}
      {#if _final?.denominator?.isShow}/ {_final.denominator?.score}{/if}
    </p>

    <p>
      {#if _resume?.isShow}
        Resume :: {_resume.score}{/if}
    </p>
  </fieldset>
{/if}

<slot>
  {#if isEditing}
    {JSON.stringify(_data)}{/if}
</slot>

<style>
  .wrapper {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
  }
</style>
